package me.Destro168.FC_Bans.Commands;

import me.Destro168.FC_Bans.FC_Bans;
import me.Destro168.FC_Bans.PunishmentManager;
import me.Destro168.FC_Bans.Utils.BanMsgLib;
import me.Destro168.FC_Bans.Utils.FC_BansPermissions;
import me.Destro168.FC_Suite_Shared.ArgParser;

import org.bukkit.command.Command;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;
import org.bukkit.craftbukkit.command.ColouredConsoleSender;
import org.bukkit.entity.Player;

public class CheckCE implements CommandExecutor
{
	PunishmentManager record;
	BanMsgLib msgLib;
	Player player;
	ColouredConsoleSender console;
	
	public CheckCE() { }
	
	public boolean onCommand(CommandSender sender, Command cmd, String commandLabel, String[] args)
    {
		msgLib = new BanMsgLib(player);
		ArgParser ap = new ArgParser(args);
		FC_BansPermissions perms;
		
		if (sender instanceof Player)
		{
			player = (Player) sender;
			perms = new FC_BansPermissions(player);
			msgLib = new BanMsgLib(player);
		}
		else if (sender instanceof ColouredConsoleSender)
		{
			console = (ColouredConsoleSender) sender;
			perms = new FC_BansPermissions(true);
			msgLib = new BanMsgLib(console);
		}
		else
		{
			FC_Bans.plugin.getLogger().info("Unknown command sender, returning check command.");
			return false;
		}
		
		if (perms.canCheck() == false)
			return msgLib.errorNoPermission();
		
		if (ap.getArg(0).equals(""))
			return true;
		
		//First argument is check so get name from 2nd argument.
		record = new PunishmentManager(args[0]);
		
		//Send the player the warning list.
		record.showWarningList(sender);
		
		//Check for ban
		msgLib.cm(0, args[0] + " will be unbanned on: " + record.getCorrectUnbanDate());

		//Check for mute
		msgLib.cm(0, args[0] + " will be unmuted on: " + record.getCorrectUnmuteDate());
		
		//Always return true.
		return true;
	}
}
