package me.Destro168.FC_Suite_Shared;

import org.bukkit.ChatColor;
import org.bukkit.craftbukkit.command.ColouredConsoleSender;
import org.bukkit.entity.Player;

public class MessageLib
{
	Player player;
	ColouredConsoleSender console;
	
	public MessageLib(Player player_) { player = player_; console = null; }
	public MessageLib(ColouredConsoleSender console_) { console = console_; player = null; }
	
	public boolean successCommand()
	{
		return sendTheMessage(FC_Suite_Shared.aquaTag + "Successfully performed command!");
	}
	
	public boolean errorInvalidCommand()
	{
		return sendTheMessage(FC_Suite_Shared.redTag + "Invalid Command Usage.");
	}
	
	public boolean errorNoPermission()
	{
		return sendTheMessage(FC_Suite_Shared.redTag + "You do not have access to this command.");
	}
	
	public boolean errorPlayerNotOnline()
	{
		return sendTheMessage(FC_Suite_Shared.redTag + "Player is not online!");
	}
	
	public boolean errorPlayerNotFound()
	{
		return sendTheMessage(FC_Suite_Shared.redTag + "Player is not online!");
	}
	
	public void cm(int color, String message)
	{
		if (color == 0)
		{
			sendTheMessage(ChatColor.GREEN + message);
		}
		else if (color == 1)
		{
			sendTheMessage(ChatColor.GOLD + message);
		}
		else if (color == 2)
		{
			sendTheMessage(ChatColor.BLUE + message);
		}
		else if (color == 3)
		{
			sendTheMessage(ChatColor.RED + message);
		}
		else if (color == 4)
		{
			sendTheMessage(ChatColor.DARK_GREEN + message);
		}
		else if (color == 5)
		{
			sendTheMessage(ChatColor.DARK_RED + message);
		}
		else if (color == 6)
		{
			sendTheMessage(ChatColor.GRAY + "" + ChatColor.ITALIC + message);
		}
		else if (color == 7)
		{
			sendTheMessage(ChatColor.DARK_GRAY + message);
		}
		else if (color == 8)
		{
			sendTheMessage(ChatColor.YELLOW + message);
		}
		else if (color == 98)
		{
			sendTheMessage(ChatColor.GREEN + ".: " + ChatColor.YELLOW + ChatColor.ITALIC + ChatColor.BOLD + message + ChatColor.GREEN + " :.");
		}
		else if (color == 99)
		{
			sendTheMessage(ChatColor.GREEN + ".:" + ChatColor.YELLOW + " RPG Mod Help! " + ChatColor.GREEN + ":. " +
					ChatColor.YELLOW + "Page " + message);
		}
	}
	
	public void cm2(int color, String m1, String m2)
	{
		if (color == 0)
		{
			sendTheMessage(ChatColor.GRAY + "" + ChatColor.ITALIC + m1 + ": " + ChatColor.YELLOW + m2);
		}
		else if (color == 1)
		{
			sendTheMessage(ChatColor.RED + "" + ChatColor.ITALIC + m1 + ": " + ChatColor.GREEN + m2);
		}
		else if (color == 2)
		{
			sendTheMessage(ChatColor.RED + "" + ChatColor.ITALIC + m1 + ": " + ChatColor.YELLOW + m2);
		}
		else if (color == 3)
		{
			sendTheMessage(ChatColor.DARK_GREEN + "" + ChatColor.ITALIC + m1 + ": " + ChatColor.GREEN + m2);
		}
		else if (color == 4)
		{
			sendTheMessage(ChatColor.GOLD + "" + ChatColor.ITALIC + m1 + ": " + ChatColor.YELLOW + m2);
		}
		else if (color == 5)
		{
			sendTheMessage(ChatColor.GRAY + "" + ChatColor.ITALIC + m1 + ": " + ChatColor.GREEN + m2);
		}
	}
	
	private boolean sendTheMessage(String msg)
	{
		if (player != null)
			player.sendMessage(msg);
		else if (console != null)
			console.sendMessage(msg);
		
		return true;
	}
}

