package me.Destro168.FC_Bans.Commands;

import me.Destro168.FC_Bans.Utils.ConfigSettingsManager;
import me.Destro168.FC_Bans.Utils.BanMsgLib;
import me.Destro168.FC_Bans.Utils.FC_BansPermissions;

import org.bukkit.ChatColor;
import org.bukkit.command.Command;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

public class helpCE implements CommandExecutor
{
	Player player;
	BanMsgLib msgLib;
	
	public void cm(String message) { player.sendMessage(ChatColor.GRAY + "" + ChatColor.ITALIC + message); }
	
	public helpCE() { }
	
	public boolean onCommand(CommandSender sender, Command cmd, String commandLabel, String[] args)
    {
		//Variable Declarations
		player = (Player) sender;
		msgLib = new BanMsgLib(player);
		ConfigSettingsManager csm = new ConfigSettingsManager();
		FC_BansPermissions perms = new FC_BansPermissions(player);
		
		//Atempt to parse for a command with the proper permissions.
		try
		{
			if (perms.isAdmin())
			{
				if (args[0] != null)
				{
					if (args[0].equalsIgnoreCase("global") == true)
					{
						if (csm.getGlobalAnnouncementsEnabled() == true)
						{
							csm.setGlobalAnnouncementsEnabled(false);
							cm("Sucessfully disabled global announcements.");
						}
						else
						{
							csm.setGlobalAnnouncementsEnabled(true);
							cm("Sucessfully enabled global announcements.");
						}
						
						return true;
					}
					else if (args[0].equalsIgnoreCase("autowarn"))
					{
						if (csm.getAutoShowWarningList() == true)
						{
							csm.setAutoShowWarningList(false);
							cm("Sucessfully disabled automatic warnings.");
						}
						else
						{
							csm.setGlobalAnnouncementsEnabled(true);
							cm("Sucessfully enabled automatic warnings.");
						}
						
						return true;
					}
				}
			}
		}
		catch (ArrayIndexOutOfBoundsException e) { }
		
		if (perms.isUser())
		{
			player.sendMessage(ChatColor.GREEN + ".:" + ChatColor.YELLOW + ChatColor.BOLD + ChatColor.ITALIC + " FC_Bans Help " + ChatColor.GREEN + ":.");
			
			//Only display commands they have permission to below.
			if (perms.canKick())
				cm("/kick [name]");
			
			if (perms.canBan())
			{
				cm("/ban [name] [duration] [reason] [reason2] [...]");
				cm("/ban ip [name] [duration] [reason] [reason2] [...]");
			}
			
			if (perms.canBanCheck())
				cm("/ban check [name]");
			
			if (perms.canBanRemove())
				cm("/ban remove [name]");
			
			if (perms.canMute())
				cm("/mute [name] [duration] [reason] [reason2] [...]");
			
			if (perms.canMuteCheck())
				cm("/mute check [name]");

			if (perms.canMuteRemove())
				cm("/mute remove [name]");
			
			if (perms.canWarn())
				cm("/warn [name] [reason1] [reason2] [reason] [...]");
			
			if (perms.canWarnCheck())
				cm("/warn check [name]");
			
			if (perms.canWarnRemove())
				cm("/warn remove [name] [number]");
			
			if (perms.canWarnRemove())
				cm("/check [name]");
				
			if (perms.isAdmin())
			{
				cm("/fc_bans global" + ChatColor.YELLOW + " - Toggles global announcements on/off.");
				cm("/fc_bans autowarn" + ChatColor.YELLOW + " - Toggles auto-warnings on/off.");
			}
			
			player.sendMessage(ChatColor.GREEN + "Durations = []s[]m[]h[]d[]w where '[]' is equal to any number.");
			player.sendMessage(ChatColor.GREEN + "Example Duration: '5d3m' = 5 days and 3 minutes.");
			player.sendMessage(ChatColor.GREEN + "Example Command: " + ChatColor.YELLOW + "/ban Destro168 3h2m1s Dislikes pie.");
    	}
		else
		{
			return msgLib.errorNoPermission();
		}

		return true;
    }
}
