package me.Destro168.FC_Bans.Commands;

import me.Destro168.FC_Bans.FC_Bans;
import me.Destro168.FC_Bans.PunishmentManager;
import me.Destro168.FC_Bans.Utils.ConfigSettingsManager;
import me.Destro168.FC_Bans.Utils.BanMsgLib;
import me.Destro168.FC_Bans.Utils.FC_BansPermissions;
import me.Destro168.FC_Suite_Shared.ArgParser;

import org.bukkit.command.Command;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;
import org.bukkit.craftbukkit.command.ColouredConsoleSender;
import org.bukkit.entity.Player;

public class kickCE implements CommandExecutor
{
	Player player;
	ColouredConsoleSender console;
	
	public kickCE() { }
	
	public boolean onCommand(CommandSender sender, Command cmd, String commandLabel, String[] args)
    {
		BanMsgLib msgLib = new BanMsgLib(player);
		ArgParser fap = new ArgParser(args);
		PunishmentManager record;
		ConfigSettingsManager csm = new ConfigSettingsManager();
		FC_BansPermissions perms;
		
		if (sender instanceof Player)
		{
			player = (Player) sender;
			perms = new FC_BansPermissions(player);
			msgLib = new BanMsgLib(player);
		}
		else if (sender instanceof ColouredConsoleSender)
		{
			console = (ColouredConsoleSender) sender;
			perms = new FC_BansPermissions(true);
			msgLib = new BanMsgLib(console);
		}
		else
		{
			FC_Bans.plugin.getLogger().info("Unknown command sender, returning kick command.");
			return false;
		}
		
		//Attempt to perform the commands.
		try
		{
			//Check if the player is immune
			if (perms.isImmune(fap.getArg(0)) == true)
				return msgLib.isImmune();
			
			if (perms.canKick() == false)
				return msgLib.errorNoPermission();
			
			//Set final punish arg.
			fap.setLastArg(1);
			
			record = new PunishmentManager(args[0]);
			
			//Ban the player
			record.kickPlayer(fap.getFinalArg(), msgLib.getPunisherName());
			
			//If the global setting auto-show warning list is on, then show the warning list.
			if (csm.getAutoShowWarningList())
				record.showWarningList(sender);
			else
				msgLib.successCommand();
		}
		catch (NullPointerException e)
		{
			return msgLib.errorInvalidCommand();
		}
		catch (ArrayIndexOutOfBoundsException e) 
		{
			return msgLib.errorInvalidCommand();
		}
		
		return true;
    }
}
