package me.Destro168.FC_Bans.Utils;

import me.Destro168.FC_Suite_Shared.MessageLib;

import org.bukkit.ChatColor;
import org.bukkit.craftbukkit.command.ColouredConsoleSender;
import org.bukkit.entity.Player;

public class BanMsgLib extends MessageLib
{
	Player player;
	ColouredConsoleSender console;
	
	private final String tag = ChatColor.WHITE + "[" + ChatColor.RED + "FC_BANS" + ChatColor.WHITE + "] ";
	
	public String getPunisherName()
	{
		if (player != null)
			return player.getName();
		else if (console != null)
			return "Console";
		
		return "Unspecified";
	}
	
	public BanMsgLib(Player player_)
	{
		super(player_);
		player = (Player) player_;
	}
	
	public BanMsgLib(ColouredConsoleSender console_)
	{
		super(console_);
		console = (ColouredConsoleSender) console_;
	}
	
	public boolean alreadyIs()
	{
		return sendTheMessage(tag + "Player is already banned.");
	}
	
	public boolean isImmune()
	{
		return sendTheMessage(tag + "Target is immune to punishment.");
	}
	
	public boolean badDuration()
	{
		return sendTheMessage(tag + "Bad duration entered!");
	}
	
	private boolean sendTheMessage(String msg)
	{
		if (player != null)
			player.sendMessage(msg);
		else if (console != null)
			console.sendMessage(msg);
		
		return true;
	}
}







